StoredCollections (Oracle - Berkeley DB Java Edition API)
Date: 2014-12-16

com.sleepycat.collections

## Class StoredCollections

- java.lang.Object
- - com.sleepycat.collections.StoredCollections

-     public class StoredCollections
      extends Object

  Static methods operating on collections and maps.

  This class consists exclusively of static methods that operate on or return stored collections and maps, jointly called containers. It contains methods for changing certain properties of a container. Because container properties are immutable, these methods always return a new container instance. This allows stored container instances to be used safely by multiple threads. Creating the new container instance is not expensive and creates only two new objects.

  When a container is created with a particular property, all containers and iterators derived from that container will inherit the property. For example, if a read-uncommitted Map is created then calls to its subMap(), values(), entrySet(), and keySet() methods will create read-uncommitted containers also.

  Method names beginning with "configured" create a new container with a specified `CursorConfig` from a given stored container. This allows configuring a container for read-committed isolation, read-uncommitted isolation, or any other property supported by `CursorConfig`. All operations performed with the resulting container will be performed with the specified cursor configuration.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <E> Collection<E>` | `configuredCollection(Collection<E> storedCollection, CursorConfig config)` Creates a configured collection from a given stored collection.
    `static <E> List<E>` | `configuredList(List<E> storedList, CursorConfig config)` Creates a configured list from a given stored list.
    `static <K,V> Map<K,V>` | `configuredMap(Map<K,V> storedMap, CursorConfig config)` Creates a configured map from a given stored map.
    `static <E> Set<E>` | `configuredSet(Set<E> storedSet, CursorConfig config)` Creates a configured set from a given stored set.
    `static <K,V> SortedMap<K,V>` | `configuredSortedMap(SortedMap<K,V> storedSortedMap, CursorConfig config)` Creates a configured sorted map from a given stored sorted map.
    `static <E> SortedSet<E>` | `configuredSortedSet(SortedSet<E> storedSortedSet, CursorConfig config)` Creates a configured sorted set from a given stored sorted set.
    `static <E> Iterator<E>` | `iterator(Iterator<E> iter)` Clones an iterator preserving its current position.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### configuredCollection

          public static <E> Collection<E> configuredCollection(Collection<E> storedCollection,
                                               CursorConfig config)

      Creates a configured collection from a given stored collection.
      Parameters:
        `storedCollection` - the base collection.
        `config` - is the cursor configuration to be used for all operations performed via the new collection instance; null may be specified to use the default configuration.
      Returns:
        the configured collection.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### configuredList

          public static <E> List<E> configuredList(List<E> storedList,
                                   CursorConfig config)

      Creates a configured list from a given stored list.

      Note that this method may not be called in the JE product, since the StoredList class is not supported.

      Parameters:
        `storedList` - the base list.
        `config` - is the cursor configuration to be used for all operations performed via the new list instance; null may be specified to use the default configuration.
      Returns:
        the configured list.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### configuredMap

          public static <K,V> Map<K,V> configuredMap(Map<K,V> storedMap,
                                     CursorConfig config)

      Creates a configured map from a given stored map.
      Parameters:
        `storedMap` - the base map.
        `config` - is the cursor configuration to be used for all operations performed via the new map instance; null may be specified to use the default configuration.
      Returns:
        the configured map.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### configuredSet

          public static <E> Set<E> configuredSet(Set<E> storedSet,
                                 CursorConfig config)

      Creates a configured set from a given stored set.
      Parameters:
        `storedSet` - the base set.
        `config` - is the cursor configuration to be used for all operations performed via the new set instance; null may be specified to use the default configuration.
      Returns:
        the configured set.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### configuredSortedMap

          public static <K,V> SortedMap<K,V> configuredSortedMap(SortedMap<K,V> storedSortedMap,
                                                 CursorConfig config)

      Creates a configured sorted map from a given stored sorted map.
      Parameters:
        `storedSortedMap` - the base map.
        `config` - is the cursor configuration to be used for all operations performed via the new map instance; null may be specified to use the default configuration.
      Returns:
        the configured map.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### configuredSortedSet

          public static <E> SortedSet<E> configuredSortedSet(SortedSet<E> storedSortedSet,
                                             CursorConfig config)

      Creates a configured sorted set from a given stored sorted set.
      Parameters:
        `storedSortedSet` - the base set.
        `config` - is the cursor configuration to be used for all operations performed via the new set instance; null may be specified to use the default configuration.
      Returns:
        the configured set.
      Throws:
        `ClassCastException` - if the given container is not a StoredContainer.

    - #### iterator

          public static <E> Iterator<E> iterator(Iterator<E> iter)

      Clones an iterator preserving its current position.
      Parameters:
        `iter` - an iterator to clone.
      Returns:
        a new `Iterator` having the same position as the given iterator.
      Throws:
        `ClassCastException` - if the given iterator was not obtained via a `StoredCollection` method.

Copyright (c) 2004, 2014 Oracle and/or its affiliates. All rights reserved.